# Lab7 -- Stress testing 

## Report

| Target | RPS |
| ------ | --- |
| GetSpec | 0.87 |
| Calculate Price (fixed_price plan)| 0.82 |
| Calculate Price (minute plan) | 1.01 |

### AB screenshots
![AB_GetSpec](AB_GetSpec.png)
![AB_CalculatePrice_Fixed](AB_CalculatePrice_FixedPricePlan.png)
![AB_CalculatePrice_Minute](AB_CalculatePrice_MinutePlan.png)

### Artilerry screenshots
![RandomBashScreenshot](ArtilleryRandomStuff.png)

![Report_0](Artillery_Report_0.png)
![Report_1](Artillery_Report_1.png)



## Introduction

Wooo-hoo, finally some lab where you won't need to code(I'm happy as much as you). In this lab we are going to look into stress testing techniques and technologies, and test our own services until they crush. ***Let's roll!***

## Stress testing

Stress testing is needed to understand the bearable workload on your services, so your application won't crush in the middle of working day, and all your customers won't leave you. It is used to test both hardware and software parts of the product. To test mostly software you may launch stress testing locally, so you will be able to understand which requests are lagging and which parts of your product you possibly will need to improve. To test both software and ifrastructure you should use external stress testing.

To perform our stress testing we are going to use Apache Benchmark testing tool.


## Lab
 
Ok, here we go, Stress testing lab will be pretty simple though
1. Create your fork of the `
Lab7 - Stress testing
` repo and clone it. [***Here***](https://gitlab.com/sqr-inno/lab7-stress-testing)
2. Now, let's install apache benchmark testing tool:
```sh
sudo apt install apache2-utils
```
To run apache benchmark we need to run:
```sh
ab -m "GET" _our_request_
```
To understand workload overall, we will need to call this command to all of our requests, to see how much requests can be performed in second.

3. In the previous lab we had worked with artillery.io, so why change now? Let's use it for its original purpose - load testing. In case if you need any asistance in that, look into [here](https://artillery.io/docs/guides/guides/http-reference.html#TLS-SSL). Here is a config we are going to use today, it is really like the one we've used in our previous lab.
```yaml
config:
  target: "https://script.google.com/macros/s/{your_key}"
  phases:
    - duration: 10
      arrivalCount: 100
scenarios:
  - name: "Fuzz some stuff"
    flow:
      - get:
          url: "/exec?service=calculatePrice&email=golden&type=luxury&plan=minute&distance=100&planned_distance=100&time=110&planned_time=100&inno_discount=yes"
```
To run artillery with generating report we need ot execute:
```sh
artillery run -o result.json ./example.yaml
```
Afterwards we will be able to visualise it, by:
```sh
artillery report result.json
```
Let's make it a bit more interesting, usually load tests consists of few phases, like Warm up, Ramp up and Constant workload, let's add them to our phases:
```yaml
 - duration: 60
      arrivalRate: 5
      name: Warm up
    - duration: 120
      arrivalRate: 5
      rampTo: 50
      name: Ramp up load
    - duration: 600
      arrivalRate: 50
      name: Sustained load
```
Plus to imitate user actions we can add one more request pause between them:
```yaml
 flow:
      - get:
          url: "/exec?service=calculatePrice&email=golden&type=luxury&plan=minute&distance=100&planned_distance=100&time=110&planned_time=100&inno_discount=yes"
      - think: 2
      - get:
          url: "/exec?service=calculatePrice&email=golden&type=luxury&plan=minute&distance=100&planned_distance=100&time=110&planned_time=100&inno_discount=yes"

```
Now let's run it once again and watch on the report.
That's it, lab is really simple. 
## Homework

As a homework you will need to open this [link](https://docs.google.com/spreadsheets/d/1lLigF6um8pKH2IGZNt9xXcl8quPtFPzmVtt5RCLeCqw/edit#gid=0), load test your service and provide the results of your test as a screenshot attached to the readme file with Artillery. Please establish how much rps you can get for (GetSpec, CalculatePrice with fixed_price plan, CalculatePrice with minute plan) and provide screenshots of the report and load testing execution(with user in bash shell) as well as your `test.yaml` file. 
**Lab is counted as done, if pipelines are passing. and tests are developped**

